//	Author Mircho Mirev, v 0.1, 13.10.2003
//	Duplicate contents of an input field into other input fields
//	assign an attribute to the source input field - dup="id1,id2,id3"
//	where id1, id2, id3 are the ids of the destination input fields separated by ,
//	Cnages to v 0.2, 13.04.2004
//  Added select field duplication


//hide from global namespace
var hDupContents = 
{
	name : 'duplicate contents of fields'
}

hDupContents.autoInitDuplicate = function()
{
	var hInputs = document.getElementsByTagName( 'INPUT' )
	var hInputsCount = hInputs.length
	
	for( var nI = 0; nI < hInputsCount; nI++ )
	{
		var hInput = hInputs[ nI ]
		hDupContents.attachDuplicateContents( hInput )
	}


	var hSelects = document.getElementsByTagName( 'SELECT' )
	var hSelectsCount = hSelects.length
	
	for( var nI = 0; nI < hSelectsCount; nI++ )
	{
		var hSelect = hSelects[ nI ]
		hDupContents.attachDuplicateSelIndex( hSelect )
	}
}

hDupContents.attachDuplicateContents = function( hInput )
{
	var sDupAttr = hInput.getAttribute( 'dup' )
	if( sDupAttr != null && sDupAttr.toString().length > 0 )
	{
		if( hInput.attachEvent )
		{
			hInput.attachEvent( "onchange", hDupContents.duplicateContents )
			hInput.attachEvent( "onkeyup", hDupContents.duplicateContents )
		}
		else if( hInput.addEventListener )
		{
			hInput.addEventListener( "change", hDupContents.duplicateContents, true )
			hInput.addEventListener( "keyup", hDupContents.duplicateContents, true )
		}
	}
}

hDupContents.duplicateContents = function( hEvent )
{
	if( hEvent == null )
	{
		hEvent = window.event
	}
	hElement = ( hEvent.srcElement ) ? hEvent.srcElement : hEvent.originalTarget
	hDupContents.duplicateContentsElement( hElement )
}


hDupContents.duplicateContentsElement = function( hElement )
{
	if( hElement.type == 'text' )
	{
		var sDupAttr = hElement.getAttribute( 'dup' )
		if( sDupAttr != null && sDupAttr.toString().length > 0 )
		{
			var aDups = sDupAttr.split( ',' )
			for( var nI = 0; nI < aDups.length; nI++ )
			{
				var sID = aDups[ nI ].replace( /^\s*(.*)\s*$/g, '$1' )
				document.getElementById( sID ).value = hElement.value

				if( document.createEvent )
				{
					var hChangeEvent = document.createEvent( 'Events' )
					hChangeEvent.initEvent( 'change', 0, 1 )
					document.getElementById( sID ).dispatchEvent( hChangeEvent )
				}
				else if( document.fireEvent )
				{
					document.getElementById( sID ).fireEvent( 'onchange' )
				}

			}
		}
	}
}

hDupContents.attachDuplicateSelIndex = function( hSelect )
{
	var sDupAttr = hSelect.getAttribute( 'dup' )
	if( sDupAttr != null && sDupAttr.toString().length > 0 )
	{
		if( hSelect.attachEvent )
		{
			hSelect.attachEvent( "onchange", hDupContents.duplicateSelIndex )
			hSelect.attachEvent( "onkeyup", hDupContents.duplicateSelIndex )
		}
		else if( hSelect.addEventListener )
		{
			hSelect.addEventListener( "change", hDupContents.duplicateSelIndex, true )
			hSelect.addEventListener( "keyup", hDupContents.duplicateSelIndex, true )
		}
	}
}

hDupContents.duplicateSelIndex = function( hEvent )
{
	if( hEvent == null )
	{
		hEvent = window.event
	}
	hElement = ( hEvent.srcElement ) ? hEvent.srcElement : hEvent.originalTarget
	hDupContents.duplicateSelIndexElement( hElement )
}

hDupContents.duplicateSelIndexElement = function( hElement )
{
	if( hElement.type == 'select-one' )
	{
		var sDupAttr = hElement.getAttribute( 'dup' )
		if( sDupAttr != null && sDupAttr.toString().length > 0 )
		{
			var aDups = sDupAttr.split( ',' )
			for( var nI = 0; nI < aDups.length; nI++ )
			{
				var sID = aDups[ nI ].replace( /^\s*(.*)\s*$/g, '$1' )
				document.getElementById( sID ).selectedIndex = hElement.selectedIndex
			}

			if( document.createEvent )
			{
				var hChangeEvent = document.createEvent( 'Events' )
				hChangeEvent.initEvent( 'change', 0, 1 )
				document.getElementById( sID ).dispatchEvent( hChangeEvent )
			}
			else if( document.fireEvent )
			{
				document.getElementById( sID ).fireEvent( 'onchange' )
			}
		}
	}
}

hDupContents.stopDuplicate = function( hInput )
{
	hInput.removeAttribute( 'dup' )
}

hDupContents.startDuplicate = function( hInput, sInputs )
{
	hInput.setAttribute( 'dup', sInputs )
}

if( window.attachEvent )
{
	window.attachEvent( "onload", hDupContents.autoInitDuplicate )
}
else if( window.addEventListener )
{
	window.addEventListener( "load", hDupContents.autoInitDuplicate, true )
}